registerPaint('star-bg', class {
  static get inputProperties () {
    return ['--star-size']
  }

  /**
   * 在paint方法里绘制图像
   * @param ctx 画笔
   * @param size 画布尺寸
   * @param properties css自定义属性
   */
  paint (ctx, size, properties) {
    const maxSize = Number(properties.get('--star-size'))
    const w = size.width
    const h = size.height
    // 绘制黑色背景
    ctx.fillStyle = '#000'
    ctx.fillRect(0, 0, w, h)
    // 绘制星星
    const rad = Math.PI * 2
    for (let i = 0, num = (w + h) / 4; i < num; i ++) {
      const x = Math.round(Math.random() * w)
      const y = Math.round(Math.random() * h)
      const r = Math.round(Math.random() * maxSize)
      const a = (Math.round(Math.random() * 90) + 10) / 100
      ctx.beginPath()
      ctx.fillStyle = `rgba(255, 255, 255, ${a})`
      ctx.arc(x, y, r, 0, rad)
      ctx.fill()
    }
  }
})
